Loading...
Searching...
No Matches
basix::quadrature Namespace Reference

Quadrature rules. More...

## Enumerations

enum class | type { Default = 0 , gauss_jacobi = 1 , gll = 2 , xiao_gimbutas = 3 , zienkiewicz_taylor = 20 , keast = 21 , strang_fix = 22 }
| Quadrature type.

## Functions

template<std::floating_point T>
std::array< std::vector< T >, 2 > | gauss_jacobi_rule (T a, int m)
| Get the Gauss-Jacobi rule for the interval for integrating f(x) * (1-x)^a on the interval [0, 1].
template<std::floating_point T>
std::array< std::vector< T >, 2 > | make_quadrature (const quadrature::type rule, cell::type celltype, polyset::type polytype, int m)
| Make a quadrature rule on a reference cell.
quadrature::type | get_default_rule (cell::type celltype, int m)
| Get the default quadrature type for the given cell and order.
template<std::floating_point T>
std::vector< T > | get_gll_points (int m)
| Get Gauss-Lobatto-Legendre (GLL) points on the interval [0, 1].
template<std::floating_point T>
std::vector< T > | get_gl_points (int m)
| Get Gauss-Legendre (GL) points on the interval [0, 1].

## Detailed Description

Quadrature rules.

## Function Documentation

## gauss_jacobi_rule()

template<std::floating_point T>

std::array< std::vector< T >, 2 > basix::quadrature::gauss_jacobi_rule | ( | T | a,
|  | int | m )

Get the Gauss-Jacobi rule for the interval for integrating f(x) * (1-x)^a on the interval [0, 1].

Template Parameters

  The | floating point type.

Parameters

  [in] | a | The exponent a.
  [in] | m | The number of points.

Returns
  Points and weights of a Gauss-Jacobi rule.

## make_quadrature()

template<std::floating_point T>

std::array< std::vector< T >, 2 > basix::quadrature::make_quadrature | ( | const quadrature::type | rule,
|  | cell::type | celltype,
|  | polyset::type | polytype,
|  | int | m )

Make a quadrature rule on a reference cell.

Template Parameters

  T | The floating point type.

Parameters

  [in] | rule | Type of quadrature rule (or use quadrature::Default).
  [in] | celltype | Cell type.
  [in] | polytype | Polyset type.
  [in] | m | Maximum degree of polynomial that this quadrature rule will integrate exactly.

Returns
  List of points and list of weights. The number of points arrays has shape (num points, gdim).

## get_default_rule()

quadrature::type basix::quadrature::get_default_rule | ( | cell::type | celltype,
|  | int | m )

Get the default quadrature type for the given cell and order.

Parameters

  [in] | celltype | Cell type.
  [in] | m | Maximum degree of polynomial that this quadrature rule will integrate exactly.

Returns
  Quadrature type that will be used by default.

## get_gll_points()

template<std::floating_point T>

std::vector< T > basix::quadrature::get_gll_points | ( | int | m | ) |

Get Gauss-Lobatto-Legendre (GLL) points on the interval [0, 1].

Template Parameters

  T | The floating point type.

Parameters

  [in] | m | Number of points.

Returns
  Array of GLL points.

## get_gl_points()

template<std::floating_point T>

std::vector< T > basix::quadrature::get_gl_points | ( | int | m | ) |

Get Gauss-Legendre (GL) points on the interval [0, 1].

Template Parameters

  T | The floating point type.

Parameters

  [in] | m | Number of points

Returns
  Array of GL points.